!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXINMD(MM,NT,D,MI)

  IMPLICIT NONE
  INTEGER(8) :: MM,NT,M,N,L,NS,ND,K,MN,MI
  REAL(8) :: D(*) ! D((MM/MI+1)*(2*(NT+1)-MM/MI*MI)*2)
  INTEGER(8) :: NPMAX
  INTEGER(8) :: N1,M1

  CALL MXGOMP(NPMAX)    

  N1=MM/MI+1
  M1=N1*MI
  MN=N1
  IF(MM/MI-M1/MI.GE.0) THEN
     MN=MN+1
  END IF

  ND=(MM/MI+1)*(2*(NT+1)-MM/MI*MI)
  
  !$omp parallel private(NS,M,N) num_threads(NPMAX)
  !$omp do schedule(dynamic)
  DO K=0,MN-1
     M=K*MI
     NS=K*(2*(NT+1)-(K-1)*MI)+1
     IF(M.EQ.0) THEN
        D(1)=0
        D(1+ND)=1
        DO N=1,NT
           D(NS+N-M)=-1D0*N*(N+1)
           D(NS+N-M+ND)=1/D(NS+N-M)
        END DO
     ELSE
        DO N=M,NT
           D(NS+2*(N-M))=-1D0*N*(N+1)
           D(NS+2*(N-M)+1)=D(NS+2*(N-M))
           D(NS+2*(N-M)+ND)=1/D(NS+2*(N-M))
           D(NS+2*(N-M)+1+ND)=D(NS+2*(N-M)+ND)
        END DO
     END IF
  END DO
  !$omp end do
  !$omp end parallel

END SUBROUTINE SXINMD
